﻿; ********************************************
; Created on          :   25/05/2013 00:15
; OS                       :   Linux, Windows
; Link                     :   http://axtls.sourceforge.net/
; ********************************************

#SSL_SESSION_ID_SIZE = 32

#SSL_CLIENT_AUTHENTICATION = $00010000
#SSL_SERVER_VERIFY_LATER = $00020000
#SSL_NO_DEFAULT_KEY = $00040000
#SSL_DISPLAY_STATES = $00080000
#SSL_DISPLAY_BYTES = $00100000
#SSL_DISPLAY_CERTS = $00200000
#SSL_DISPLAY_RSA = $00400000
#SSL_CONNECT_IN_PARTS = $00800000

;errors that can be generated
#SSL_OK = 0
#SSL_NOT_OK = -1
#SSL_ERROR_DEAD = -2
#SSL_CLOSE_NOTIFY = -3
#SSL_ERROR_CONN_LOST = -256
#SSL_ERROR_SOCK_SETUP_FAILURE = -258
#SSL_ERROR_INVALID_HANDSHAKE = -260
#SSL_ERROR_INVALID_PROT_MSG = -261
#SSL_ERROR_INVALID_HMAC = -262
#SSL_ERROR_INVALID_VERSION = -263
#SSL_ERROR_INVALID_SESSION = -265
#SSL_ERROR_NO_CIPHER = -266
#SSL_ERROR_BAD_CERTIFICATE = -268
#SSL_ERROR_INVALID_KEY = -269
#SSL_ERROR_FINISHED_INVALID = -271
#SSL_ERROR_NO_CERT_DEFINED = -272
#SSL_ERROR_NO_CLIENT_RENOG = -273
#SSL_ERROR_NOT_SUPPORTED = -274
#SSL_X509_OFFSET = -512

;alert types that are recognized
#SSL_ALERT_TYPE_WARNING = 1
#SLL_ALERT_TYPE_FATAL = 2

;these are all the alerts that are recognized
#SSL_ALERT_CLOSE_NOTIFY = 0
#SSL_ALERT_UNEXPECTED_MESSAGE = 10
#SSL_ALERT_BAD_RECORD_MAC = 20
#SSL_ALERT_HANDSHAKE_FAILURE = 40
#SSL_ALERT_BAD_CERTIFICATE = 42
#SSL_ALERT_ILLEGAL_PARAMETER = 47
#SSL_ALERT_DECODE_ERROR = 50
#SSL_ALERT_DECRYPT_ERROR = 51
#SSL_ALERT_INVALID_VERSION = 70
#SSL_ALERT_NO_RENEGOTIATION = 100

;The ciphers that are supported
#SSL_AES128_SHA = $2f
#SSL_AES256_SHA = $35
#SSL_RC4_128_SHA = $05
#SSL_RC4_128_MD5 = $04

;build mode ids'
#SSL_BUILD_SKELETON_MODE = $01
#SSL_BUILD_SERVER_ONLY = $02
#SSL_BUILD_ENABLE_VERIFICATION = $03
#SSL_BUILD_ENABLE_CLIENT = $04
#SSL_BUILD_FULL_MODE = $05

;offsets To retrieve configuration information
#SSL_BUILD_MODE = 0
#SSL_MAX_CERT_CFG_OFFSET = 1
#SSL_MAX_CA_CERT_CFG_OFFSET = 2
#SSL_HAS_PEM = 3

;Default session sizes
#SSL_DEFAULT_SVR_SESS = 5
#SSL_DEFAULT_CLNT_SESS = 1

;X.509/X.520 distinguished name types
#SSL_X509_CERT_COMMON_NAME = 0
#SSL_X509_CERT_ORGANIZATION = 1
#SSL_X509_CERT_ORGANIZATIONAL_NAME = 2
#SSL_X509_CA_CERT_COMMON_NAME = 3
#SSL_X509_CA_CERT_ORGANIZATION = 4
#SSL_X509_CA_CERT_ORGANIZATIONAL_NAME = 5

;SSL object loader types
#SSL_OBJ_X509_CERT = 1
#SSL_OBJ_X509_CACERT = 2
#SSL_OBJ_RSA_KEY = 3
#SSL_OBJ_PKCS8 = 4
#SSL_OBJ_PKCS12 = 5

Macro SSL_X509_ERROR(A)
     #SSL_X509_OFFSET + A
EndMacro

ImportC "libaxtls.a"
     
ssl_ctx_new(options.l, num_sessions.i)
ssl_ctx_free(ssl_ctx.i)
ssl_server_new(ssl_ctx.i, client_fd.i)
ssl_client_new(ssl_ctx.i, client_fd.i, session_id.i, sess_id_size.a)
ssl_free(ssl.i)
ssl_read(ssl.i, in_data.i)
ssl_write(ssl.i, out_data.i, out_len.i)
ssl_find(ssl_ctx.i, client_fd.i)
ssl_get_session_id(ssl.i)
ssl_get_session_id_size(ssl.i)
ssl_get_cipher_id(ssl.i)
ssl_handshake_status(ssl.i)
ssl_get_config(offset.i)
ssl_display_error(error_code.i)
ssl_verify_cert(ssl.i)
ssl_get_cert_dn(ssl.i, component.i)
ssl_get_cert_subject_alt_dnsname(ssl.i, dnsindex.i)
ssl_renegotiate(ssl.i)
ssl_obj_load(ssl_ctx.i, obj_type.i, filename.i, password.i)
ssl_obj_memory_load(ssl_ctx.i, obj_type.i, Dat.i, len.i, password.i)
ssl_x509_create(ssl_ctx.i, options.l, dn.i, cert_data.i)
ssl_version()

EndImport
; IDE Options = PureBasic 5.11 (Linux - x86)
; Folding = -
; EnableUnicode
; EnableXP